package geniusweb.protocol;

import static org.junit.Assert.assertEquals;

import java.io.IOException;

import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.util.ObjectBuffer;

import geniusweb.actions.PartyId;

public class ProtocolExceptionTest {
	private ObjectBuffer jackson = new ObjectBuffer();
	private Exception exception;
	private String asString1 = "{\"cause\":null,\"stackTrace\":[],\"party\":\"party1\",\"message\":\"party1:test\",\"localizedMessage\":\"party1:test\",\"suppressed\":[]}";

	@Before
	public void before() {
		try {
			throw new ProtocolException("test", new PartyId("party1"));
			// int x = 1 / 0;
		} catch (Exception e) {
			this.exception = e;
			System.out.println(e);
		}
	}

	@Test
	public void testSerialize() throws JsonProcessingException {

		ObjectMapper jackson = new ObjectMapper();
		System.out.println(jackson.writeValueAsString(exception));
		assertEquals(asString1, jackson.writeValueAsString(exception));

	}

	// ProtocolExceptions can not be deserialized now
	@Ignore
	@Test
	public void testDeserialize() throws IOException {

		ObjectMapper jackson = new ObjectMapper();
		Exception read = jackson.readValue(asString1, ProtocolException.class);
		assertEquals(exception, read);
	}

}
